<?php
/**
 * PHP5.4からでないと対応していないUnicodeアンエスケープをPHP5.3でもできるようにしたラッパー関数
 * @param mixed   $value
 * @param int     $options
 * @param boolean $unescapee_unicode
 */
function json_xencode($value, $options = 0, $unescapee_unicode = true) {
  $v = json_encode($value);
  if($unescapee_unicode) {
    $v = unicode_encode($v);
    // スラッシュのエスケープをアンエスケープする
    $v = preg_replace('/\\\\\//', '/', $v);
  }

  return $v;
}

/**
 * Unicodeエスケープされた文字列をUTF-8文字列に戻す。
 * 参考:http://d.hatena.ne.jp/iizukaw/20090422
 * @param unknown_type $str
 */
function unicode_encode($str) {
  return preg_replace_callback("/\\\\u([0-9a-zA-Z]{4})/", "encode_callback", $str);
}

function encode_callback($matches) {
  return mb_convert_encoding(pack("H*", $matches[1]), "UTF-8", "UTF-16");
}

/**
 * 変更されたアイテムリストをエフェクト.jsに適応する
 * @param $val
 * @param $effects
 * @param $room_no
 */
function item_exp_trance($val, $room_no) { //削除、並び変えされたアイテムリスト適応
  $effect_func = json_decode(file_get_contents(save_file_dir . "data_{$room_no}/effects.json"), true);
  $val         = preg_replace("/[^0-9,]/iu", "", $val);
  $val         = explode(",", $val);
  foreach($effect_func[effects] as $all_val) {
    if(isset($all_val[message])) continue;
    $out_effects[effects][] = $all_val;
  }
  foreach($val as $cont_val) {
    //    1368381387.5487_0001
    $effect_func[effects][$cont_val][effectId] = "effects_" . ($cont_val + 1) . rand(10000000, 99999999) . "." . rand(1000, 9999) . "_0001";
    $out_effects[effects][]                    = $effect_func[effects][$cont_val];
  }
  $json_effects = preg_replace("/\//u", "\/", json_xencode($out_effects));
  file_put_contents(save_file_dir . "data_{$room_no}/effects.json", $json_effects);
  $effect_func = null;
}

/**
 * @param $room_no
 */
function item_exp_changes($room_no) { //アイテムを並び変える
  $effects = json_decode(file_get_contents(save_file_dir . "data_{$room_no}/effects.json"), true);
  foreach($effects[effects] as $key => $row) {
    $foo[$key] = $row["message"];
  }
  array_multisort($foo, SORT_ASC, $effects[effects]);
  $json_effects = preg_replace("/\//u", "\/", json_xencode($effects));
  file_put_contents(save_file_dir . "data_{$room_no}/effects.json", $json_effects);
}

function item_change_add($room_no, $item_no) { //アイテム追加、編集
  $rep_words = array('\\' => "", '"' => "", "'" => "");
  $effects   = json_decode(file_get_contents(save_file_dir . "data_{$room_no}/effects.json"), true);
  if(($effect_item[cutInTag] = $_POST[music_tag]) === "") $effect_item[cutInTag] = null;
  $effect_item[cutInTag] = strtr($effect_item[cutInTag], $rep_words);
  if(($effect_item[position] = $_POST[position]) === "") $effect_item[position] = "up,right";
  $effect_item[effectId] = "effects_" . rand(100000000, 999999999) . "." . rand(1000, 9999) . "_0001";
  if(($effect_item[message] = $_POST[music_title]) === "") return;
  $effect_item[message] = strtr($effect_item[message], $rep_words);
  if(($effect_item[soundSource] = $_POST[music_souce]) === "") $effect_item[soundSource] = null;
  //
  $efe_item_vol = preg_replace("/[^0-9.]/iu", "", $_POST[music_volume]);
  if(0 <= $efe_item_vol && $efe_item_vol <= 1) {
    $effect_item[volume] = $efe_item_vol;
  } else {
    $effect_item[volume] = dodontof_def_volume;
  }
  //
  if(($effect_item[source] = $_POST[music_img]) === "") $effect_item[source] = dodontof_def_img;
  if($_POST[music_isTail] == true) {
    $effect_item[isTail] = true;
  } else {
    $effect_item[isTail] = false;
  }
  if($_POST[music_loop_check] == true) {
    $effect_item[isSoundLoop] = true;
  } else {
    $effect_item[isSoundLoop] = false;
  }
  //
  $effect_item[displaySeconds] = preg_replace("/[^0-9]/iu", "", $effect_item[music_display_seconds]) + 0;
  $effect_item[width]          = preg_replace("/[^0-9]/iu", "", $effect_item[music_width]) + 0;
  $effect_item[height]         = preg_replace("/[^0-9]/iu", "", $effect_item[music_height]) + 0;
  if(isset($_GET[edit], $_GET[room_no], $effects[effects][$item_no][message])) { //アイテム編集
    $effects[effects][$item_no] = $effect_item;
  } elseif(isset($_GET[room_no]) && !isset($_GET[edit])) {
    $effects[effects][] = $effect_item;
  }
  $json_effects = preg_replace("/\//u", "\/", json_xencode($effects));
  file_put_contents(save_file_dir . "data_{$room_no}/effects.json", $json_effects);
}

function item_req($val, $posival = null) { //アイテム初期値or編集値読み出し
  global $effects;
  global $item_no;
  switch($val) {
    case "title":
      $edit_item = $effects[effects][$item_no][message];
      $add_item  = null;
      break;
    case "tag":
      $edit_item = $effects[effects][$item_no][cutInTag];
      $add_item  = dodontof_def_tag;
      break;
    case "img":
      $edit_item = $effects[effects][$item_no][source];
      $add_item  = dodontof_def_img;
      break;
    case "music":
      $edit_item = $effects[effects][$item_no][soundSource];
      $add_item  = null;
      break;
    case "volume":
      $edit_item = $effects[effects][$item_no][volume];
      $add_item  = dodontof_def_volume;
      break;
    case "display_seconds":
      $edit_item = $effects[effects][$item_no][displaySeconds];
      $add_item  = dodontof_def_display_seconds;
      break;
    case "loop":
      if($effects[effects][$item_no][isSoundLoop] == true) $edit_item = "checked";
      if(dodontof_def_loop == 1) $add_item = "checked";
      break;
    case "isTail":
      if($effects[effects][$item_no][isTail] == true) $edit_item = "checked";
      if(dodontof_def_isTail == 1) $add_item = "checked";
      break;
    case "width":
      $edit_item = $effects[effects][$item_no][width];
      $add_item  = dodontof_def_width;
      break;
    case "height":
      $edit_item = $effects[effects][$item_no][height];
      $add_item  = dodontof_def_height;
      break;
    case "position":
      if($effects[effects][$item_no][position] == $posival) $edit_item = "selected";
      if(dodontof_def_position == $posival) $add_item = "selected";
      break;
  }
  if(isset($_GET[room_no], $_GET[edit])) {
    echo $edit_item;
  } elseif(isset($_GET[room_no])) {
    echo $add_item;
  }
  $edit_item = null;
  $add_item  = null;
}

?>
